Index: GTP/trunk/App/Demos/Illum/Ogre/src/DiffuseTest/include/DiffuseTest.h
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/src/DiffuseTest/include/DiffuseTest.h	(revision 1834)
+++ GTP/trunk/App/Demos/Illum/Ogre/src/DiffuseTest/include/DiffuseTest.h	(revision 1868)
@@ -26,8 +26,9 @@
 #include "ExampleApplication.h"
 #include "OgreIlluminationManager.h"
-
-float causize = 10;
-float cauintens = 40;
+#include "FrameCapture.h"
+
+FrameCapture* capture;
 int scene = 3;
+
 // Listener class for frame updates
 class RaytraceDemoListener : public ExampleFrameListener
@@ -47,4 +48,17 @@
 		this->objectNode = objectNode;
 	  }
+
+	void moveCamera()
+    {/*
+	   mCamera->yaw(mRotX);
+       mCamera->pitch(mRotY);
+       mCamera->moveRelative(mTranslateVector);*/
+
+		mCamera->getParentSceneNode()->yaw(mRotX, Node::TransformSpace::TS_WORLD);
+		mCamera->getParentSceneNode()->pitch(mRotY, Node::TransformSpace::TS_LOCAL);
+		mCamera->getParentSceneNode()->translate(mTranslateVector, Node::TransformSpace::TS_LOCAL);
+		
+    }
+
 	bool processUnbufferedKeyInput(const FrameEvent& evt)
     {
@@ -219,5 +233,20 @@
                 "O: " + StringConverter::toString(mCamera->getDerivedOrientation()));
         }
-
+        if (mInputDevice->isKeyDown(KC_N) && mTimeUntilNextToggle <= 0)
+        {
+			capture->playEvent();
+            mTimeUntilNextToggle = 1;
+        }
+		if (mInputDevice->isKeyDown(KC_B) && mTimeUntilNextToggle <= 0)
+        {
+			capture->recordEvent();
+            mTimeUntilNextToggle = 1;
+        }
+		if (mInputDevice->isKeyDown(KC_M) && mTimeUntilNextToggle <= 0)
+        {
+			capture->setSaving();
+			capture->playEvent();
+            mTimeUntilNextToggle = 1;
+        }
 
 		lastTime = thisTime;
@@ -357,4 +386,5 @@
 		mCamera->setNearClipDistance(0.1);
 		
+		capture  = new FrameCapture(mWindow);
 		switch (scene)
 		{
@@ -708,4 +738,6 @@
 		mFrameListener->setPriority(1);
 		OgreIlluminationManager::getSingleton().setPriority(10);
+		capture->setPriority(6);
+        mRoot->addFrameListener(capture);
         mRoot->addFrameListener(&OgreIlluminationManager::getSingleton());
 		mRoot->addFrameListener(mFrameListener);
Index: GTP/trunk/App/Demos/Illum/Ogre/src/DiffuseTest/scripts/DiffuseTest.vcproj
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/src/DiffuseTest/scripts/DiffuseTest.vcproj	(revision 1712)
+++ GTP/trunk/App/Demos/Illum/Ogre/src/DiffuseTest/scripts/DiffuseTest.vcproj	(revision 1868)
@@ -42,5 +42,5 @@
 				Name="VCCLCompilerTool"
 				Optimization="0"
-				AdditionalIncludeDirectories="..\include;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderingRuns;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderingRuns"
+				AdditionalIncludeDirectories="..\include;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderingRuns;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderingRuns;..\..\Common\include"
 				PreprocessorDefinitions="WIN32;_DEBUG;_WINDOWS;GAMETOOLS_ILLUMINATION_MODULE"
 				MinimalRebuild="true"
@@ -133,5 +133,5 @@
 				OmitFramePointers="true"
 				EnableFiberSafeOptimizations="false"
-				AdditionalIncludeDirectories="..\include;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderingRuns;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderingRuns"
+				AdditionalIncludeDirectories="..\include;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderingRuns;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderingRuns;..\..\Common\include"
 				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;GAMETOOLS_ILLUMINATION_MODULE"
 				StringPooling="true"